Device = 16F628A 'Verzija pica 
Config INTRC_OSC_CLKOUT, MCLRE_OFF, LVP_OFF, WDT_OFF, PWRTE_OFF, CP_OFF, BODEN_OFF
Declare Bus_SCL On   
'---------------------------LCD-------------------------------- 	
		Declare LCD_DTPin = PORTB.0
        Declare LCD_RSPin = PORTB.4
		Declare LCD_ENPin = PORTA.3
		Declare LCD_Interface = 4	' 4-bit Interface
		Declare LCD_Lines = 2
		Declare LCD_Type = 0
		CMCON = 7
'---------------------------Adresler----------------------------
Dim FREQ_step As Word     'Frekans desetina
Dim FREQ_Tam As Word      'Frekans Cijeli broj
Dim FREQ_Onda As Word     'Frekans step
Dim FREQ As Word          'Frekans information variable
Dim F_KONTROL As Word        'KONTROL defined variable

Dim LO As FREQ.LowByte    'Frekans low byte of variable
Dim HI As FREQ.HighByte   'Frekans high byte of variable  

'--------------------------Portlar------------------------------
Symbol SDA = PORTA.1         'SDA of I2C is connected to PORTA.1    
Symbol SCL = PORTA.0         'Scl of I2C depends on PORTA.0
Symbol LED = PORTA.2         'connected to LED PORTA.2

PORTA=0 : PORTB=0     'PORTA and PORTB reset
'------------------------Eepromdan OKu-------------------------- 

main:
High LED
Print At 1,1, " FM TRANSMITTER "
Print At 2,1, "    NetGate     "
DelayMS 10000 '300
FREQ_step = ERead 02 'Reading the FREQUENCY value from EData
If  FREQ_step > 0   Then  Setup 'If FREQUENCY Information is Greater than 0, Tsa 
'----------------------Frekans Deitir-------------------------
Freq_set:
FREQ_Onda = (FREQ_step*10/2)//100
FREQ_Tam =  (FREQ_step*10/2)/100
Print  At 1,1, "Set : ", Dec FREQ_Tam, ".", Dec2 FREQ_Onda,"MHz " 'LCD Yaz
Print  At 2,1, "NetGate 300mW " 'LCD Yaz
DelayMS 28 '28
If  PORTB.5=1   Then    Up_freq
If  PORTB.7=1   Then    Down_freq
If  PORTB.6=1   Then    Set_freq
'----------------------- Tsa5511 e yaz--------------------------
FREQ = FREQ_step
I2COut SDA,SCL,$C2, [HI,LO,$8E,$10]
GoTo Freq_set

Up_freq:
            FREQ_step=FREQ_step + 1                  'ierii 5 artir
            If FREQ_step > 2160 Then FREQ_step=1750 'ierik 10800 dan byk ise 8750 yap
            GoTo Freq_set
Down_freq:
            FREQ_step=FREQ_step-1                    'ierii 5 azalt
            If FREQ_step < 1750 Then FREQ_step=2160 'ierik 8750 den kk ise 10800 yap
            GoTo Freq_set
            
'--------------------------Edataya yaz---------------------------
Set_freq:
EWrite 02 ,[FREQ_step] 'Frekans Bilgisini Edataya yazyor 
DelayMS 50 

'----------------------- Tsa5511 setup --------------------------
Setup:
FREQ_Onda = (FREQ_step*10/2)//100
FREQ_Tam =  (FREQ_step*10/2)/100
Print  At 1,1, "UnLock ", Dec FREQ_Tam, ".", Dec2 FREQ_Onda, "MHz" 'lcd yaz
Print  At 2,1, "NetGate 300mW " 'LCD Yaz
FREQ = FREQ_step
I2COut SDA,SCL,$C2, [HI,LO,$8E,$00]
DelayMS 150 

'---------------------- Tsa5511 Control ----------------------
If  PORTB.6=1   Then    Freq_set
I2CIn SDA,SCL,$C2,[F_KONTROL]
If F_KONTROL.6=1 Then Control_lock
GoTo Setup

Control_lock:
Low LED
I2COut SDA,SCL,$C2, [HI,LO,$8E,$24]
FREQ_Onda = (FREQ_step*10/2)//100
FREQ_Tam =  (FREQ_step*10/2)/100
Print  At 1,1, "ON AIR ", Dec FREQ_Tam, ".", Dec2 FREQ_Onda, "MHz" 'lcd Yaz
Print  At 2,1, "NetGate 300mW" 'LCD Yaz

K_buton:
DelayMS 20 '20
If  PORTB.5=1   Then    LCD_Led_Off
If  PORTB.7=1   Then    LCD_Led_On
If  PORTB.6=1   Then    Freq_set
GoTo K_buton

LCD_Led_On:
High LED
GoTo K_buton

LCD_Led_Off:
Low LED
GoTo K_buton

End
